package rwd.ocl.constraintdiagram;

/**
 * @author Octavian Patrascoiu
 *
 */
//
// Token
//
class Token {
	public Token() {
	}
	public Token(int code) {
		this.code = code;
	}
	public Token(int code, String info) {
		this.code = code;
		this.info = info;
	}
	
	public boolean isLP() {
		return code == Token.LP;
	}
	public boolean isRP() {
		return code == Token.RP;
	}
	public boolean isID() {
		return code == Token.ID;
	}

	public String toString() {
		return code+":"+info;
	}
	//
	// Local properties
	//
	protected int code = BAD;
	protected String info = "";
	
	static int BAD = 0;
	static int ID = 1;
	static int LP = 2;
	static int RP = 3;
	static int END = 4;
}
