package rwd.rules.autoproof;

import rwd.abstractsyntax.spiderdiagram.Diagram;
import rwd.rules.Proof;
import rwd.rules.nospec.ToDNFRule;
import rwd.rules.application.RuleAppliesToJustADiagram;

public class MakerOfDisNF {
	public static Proof turnToDisjNF(Diagram d) {
		//Diagram d = d.getClone();
		Proof p = new Proof(d);
		ToDNFRule ssr = (ToDNFRule)ToDNFRule.getRule();
		RuleAppliesToJustADiagram rajd = new RuleAppliesToJustADiagram(d);
		Diagram outcome = ssr.applyRule(rajd);
		if (!outcome.equals(d)) {
			p.addStepAtEnd(ssr, rajd, outcome);
		}
		return p;
	}
}
