package rwd.rules.heuristics;

import rwd.abstractsyntax.spiderdiagram.Diagram;
import rwd.rules.*;
import rwd.rules.autoproof.*;

public class HeuristicCalculatorCountUnitaryParts
	implements HeuristicCalculator {
	public double calcHeuristic(Diagram d1, Diagram d2) {
		//Proof p = null;
		try {
			//p = 
			AutoProofWriterBetter.writeProof(d1, d2);
			return Math.log(
				Math.abs(
					d1.getUnitaryParts().size() - d2.getUnitaryParts().size()));
		} catch (NoProofException x) {
			return Double.MAX_VALUE;
		}
	}
}
