package rwd.rules.nospec;
import rwd.abstractsyntax.spiderdiagram.Diagram;
import rwd.rules.Rule;
import rwd.rules.application.RuleAppliesToJustADiagram;
import rwd.rules.application.RuleApplicationSpec;
import rwd.abstractsyntax.spiderdiagram.OrCompoundDiagram;
import java.util.Vector;

public class OrIdempotentRule extends RuleNoSpec {
	private OrIdempotentRule() {
		super("sd: idempotency of OR");
	}
	private static Rule example = null;

	public static Rule getRule() {
		if (example == null) {
			example = new OrIdempotentRule();
		}
		return example;
	}
    public boolean isInvertible(){
        return true;
    }

	public boolean canApplyTo(Diagram d) {
		return true;
	}
	public Diagram applyRule(RuleApplicationSpec r) {
		RuleAppliesToJustADiagram rajd = (RuleAppliesToJustADiagram) r;
		Diagram d = rajd.d;
		Vector diagrams = new Vector();
		diagrams.add(d);
		diagrams.add(d);
		return new OrCompoundDiagram(diagrams, "outcome");
	}
}
