package rwd.views.graph;
import java.util.TreeSet;
import java.util.Vector;
import java.util.Iterator;
//import rwd.views.abstracttoconcrete.oldaed.OldContour;
import rwd.abstractsyntax.eulerdiagram.Contour;

public class Planariser {
	static Position[][][][] posns = new Position[2][2][2][2];

	static Vector history = new Vector();
	// contains Graph,Comaprable,Comparable,C,C,G,C,C,C,C,...

	static {
		posns[0][0][0][0] = new Position(3, 2);
		posns[0][0][0][1] = new Position(9, 1);
		posns[0][0][1][0] = new Position(1, 2);
		posns[0][0][1][1] = new Position(10, -1);
		posns[0][1][0][0] = new Position(5, 3);
		posns[0][1][0][1] = new Position(8, 3);
		posns[0][1][1][0] = new Position(6, 4);
		posns[0][1][1][1] = new Position(7, 4);
		posns[1][0][0][0] = new Position(3, 7);
		posns[1][0][0][1] = new Position(9, 8);
		posns[1][0][1][0] = new Position(1, 7);
		posns[1][0][1][1] = new Position(10, 9);
		posns[1][1][0][0] = new Position(5, 6);
		posns[1][1][0][1] = new Position(7, 6);
		posns[1][1][1][0] = new Position(6, 5);
		posns[1][1][1][1] = new Position(7, 5);
	}

	public static boolean planarise(Graph g) {
		TreeSet labels = g.labels();
		if (labels.size() > 4) {
			/////////////////??????????? do something sensible!!!!!!!!
			/**/
			System.out.println("graph has too many labels to planarise");
		}
		if (labels.size() < 4) {
			labels.add(Contour.getContour("dummy1"));
		}
		if (labels.size() < 4) {
			labels.add(Contour.getContour("dummy2"));
		}
		if (labels.size() < 4) {
			labels.add(Contour.getContour("dummy3"));
		}
		if (labels.size() < 4) {
			labels.add(Contour.getContour("dummy4"));
		}
		Comparable c = (Comparable) (labels.iterator().next());
		return planariseFromNew(g, c, c, c, c);
	}

	public static boolean planariseAgainNew(Graph g) {
		Iterator i = history.iterator();
		while (i.hasNext()) {
			Object o = i.next();
			//System.out.println("["+o.getClass()+"]");
			//if((""+o.getClass()).equals("class aed.Contour"))
			//{ //System.out.println(""+history); }
			Graph gh = (Graph) (o);
			if (gh == g) {
				return planariseFromNew(
					g,
					(Comparable) (i.next()),
					(Comparable) (i.next()),
					(Comparable) (i.next()),
					(Comparable) (i.next()));
			} else {
				i.next();
				i.next();
				i.next();
				i.next();
			}
		}
		TreeSet labels = g.labels();
		if (labels.size() > 4) { /**/
			System.out.println("rwd.views.graph has too many labels");
		}
		if (labels.size() < 4) {
			labels.add(Contour.getContour("dummy1"));
		}
		if (labels.size() < 4) {
			labels.add(Contour.getContour("dummy2"));
		}
		if (labels.size() < 4) {
			labels.add(Contour.getContour("dummy3"));
		}
		if (labels.size() < 4) {
			labels.add(Contour.getContour("dummy4"));
		}
		Comparable c = (Comparable) (labels.iterator().next());
		return planariseFromNew(g, c, c, c, c);
	}

/*	public static boolean planariseAgain(Graph g) {
		Iterator i = history.iterator();
		while (i.hasNext()) {
			Object o = i.next();
			//System.out.println("["+o.getClass()+"]");
			//if((""+o.getClass()).equals("class aed.Contour"))
			//{ //System.out.println(""+history); }
			Graph gh = (Graph) (o);
			if (gh == g) {
				return planariseFrom(
					g,
					(Comparable) (i.next()),
					(Comparable) (i.next()),
					(Comparable) (i.next()),
					(Comparable) (i.next()));
			} else {
				i.next();
				i.next();
				i.next();
				i.next();
			}
		}
		TreeSet labels = g.labels();
		if (labels.size() > 4) { 
			System.out.println("rwd.views.graph has too many labels");
		}
		if (labels.size() < 4) {
			labels.add(OldContour.getContour("dummy1"));
		}
		if (labels.size() < 4) {
			labels.add(OldContour.getContour("dummy2"));
		}
		if (labels.size() < 4) {
			labels.add(OldContour.getContour("dummy3"));
		}
		if (labels.size() < 4) {
			labels.add(OldContour.getContour("dummy4"));
		}
		Comparable c = (Comparable) (labels.iterator().next());
		return planariseFrom(g, c, c, c, c);
	}*/

/*	private static boolean planariseFrom(
		Graph g,
		Comparable ch1,
		Comparable ch2,
		Comparable ch3,
		Comparable ch4) { // check that g has less than or equal to 4 labels
		// make up a 4-tuple for labels of g (include fictitious ones)
		boolean haveMetHistorical = false;
		TreeSet labels = g.labels();
		if (labels.size() > 4) {
			System.out.println("rwd.views.graph has too many labels");
		}
		if (labels.size() < 4) {
			labels.add(OldContour.getContour("dummy1"));
		}
		if (labels.size() < 4) {
			labels.add(OldContour.getContour("dummy2"));
		}
		if (labels.size() < 4) {
			labels.add(OldContour.getContour("dummy3"));
		}
		if (labels.size() < 4) {
			labels.add(OldContour.getContour("dummy4"));
		}
		// iterate through lists of labels L=<l1, l2, l3, l4>
		// and vertices v
		Iterator i1 = labels.iterator();
		while (i1.hasNext()) {
			Comparable c1 = (Comparable) (i1.next());
			Iterator i2 = labels.iterator();
			while (i2.hasNext()) {
				Comparable c2 = (Comparable) (i2.next());
				Iterator i3 = labels.iterator();
				while (i3.hasNext()) {
					Comparable c3 = (Comparable) (i3.next());
					Iterator i4 = labels.iterator();
					while (i4.hasNext()) {
						Comparable c4 = (Comparable) (i4.next());
						if (!haveMetHistorical
							&& c1 == ch1
							&& c2 == ch2
							&& c3 == ch3
							&& c4 == ch4) {
							haveMetHistorical = true;
							//System.out.println("OK have met historical data");
						}
						//System.out.println("are these distinct?"+c1+c2+c3+c4);
						//System.out.println("met historical?"+haveMetHistorical);
						else if (
							haveMetHistorical
								&& c1 != c2
								&& c1 != c3
								&& c1 != c4
								&& c2 != c3
								&& c2 != c4
								&& c3 != c4) {
							//System.out.println("OK have found distinct "+c1+c2+c3+c4);
							Iterator itNodes = g.nodes().iterator();
							while (itNodes.hasNext()) {
								Node n = (Node) (itNodes.next());
								//System.out.println("edges are "+g.edges);
								// seeking situations where we can find missing edges
								if (//       v.along(3).along(4)- v.along(2).along(3).along(4)
								!g
									.edges()
									.contains(
										Edge.getEdge(
											n.along(c3).along(c4),
											n.along(c2).along(c3).along(c4)))
									&& //v.along(1).along(3).along(4)- v.along(1).along(2).along(3).along(4)
								!g
										.edges()
										.contains(
											Edge.getEdge(
												n.along(c1).along(c3).along(c4),
												n.along(c1).along(c2).along(
													c3).along(
													c4)))
									&& ((// and EITHER
								//       v                  - v.along(1)
								!g
										.edges()
										.contains(Edge.getEdge(n, n.along(c1)))
									&& //       v.along(2)        - v.along(1).along(2)
								!g
									.edges()
									.contains(
										Edge.getEdge(
											n.along(c2),
											n.along(c1).along(c2))))
										|| (// OR
								//       v.along(3)          - v.along(2).along(3)
								!g
											.edges()
											.contains(
												Edge.getEdge(
													n.along(c3),
													n.along(c2).along(c3)))
									&& //       v.along(1).along(3)- v.along(1).along(2).along(3)
								!g
									.edges()
									.contains(
										Edge.getEdge(
											n.along(c1).along(c3),
											n.along(c1).along(c2).along(
												c3))))))

									// two extra brackets here....
									{ //
									// in which case
									// fix the ordering L = <l1,l2,l3,l4> and the vertex v
									// for each vertex v2, find a set of labels from v to v2
									// and use L to convert it to 0110, for example
									// pick this position from a position array
									//System.out.println("found missing edges with");
									//System.out.println("node "+n+" and label order "+c1+c2+c3+c4);
									Iterator iNodes2 = g.nodes().iterator();
									while (iNodes2.hasNext()) {
										Node toBePositioned =
											(Node) (iNodes2.next());
										TreeSet symmDiff =
											n.symmDiff(toBePositioned);
										toBePositioned.setPosition(
											posns[getInt(
												symmDiff.contains(c1))][getInt(
												symmDiff.contains(c2))][getInt(
												symmDiff.contains(c3))][getInt(
												symmDiff.contains(c4))]);
									}
									updateHistory(g, c1, c2, c3, c4);
									return true;
								}
							}
						}
					}
				}
			}
		}
		return false;
	}*/
	private static boolean planariseFromNew(
		Graph g,
		Comparable ch1,
		Comparable ch2,
		Comparable ch3,
		Comparable ch4) { // check that g has less than or equal to 4 labels
		// make up a 4-tuple for labels of g (include fictitious ones)
		boolean haveMetHistorical = false;
		TreeSet labels = g.labels();
		if (labels.size() > 4) { /**/
			System.out.println("rwd.views.graph has too many labels");
		}
		if (labels.size() < 4) {
			labels.add(Contour.getContour("dummy1"));
		}
		if (labels.size() < 4) {
			labels.add(Contour.getContour("dummy2"));
		}
		if (labels.size() < 4) {
			labels.add(Contour.getContour("dummy3"));
		}
		if (labels.size() < 4) {
			labels.add(Contour.getContour("dummy4"));
		}
		// iterate through lists of labels L=<l1, l2, l3, l4>
		// and vertices v
		Iterator i1 = labels.iterator();
		while (i1.hasNext()) {
			Comparable c1 = (Comparable) (i1.next());
			Iterator i2 = labels.iterator();
			while (i2.hasNext()) {
				Comparable c2 = (Comparable) (i2.next());
				Iterator i3 = labels.iterator();
				while (i3.hasNext()) {
					Comparable c3 = (Comparable) (i3.next());
					Iterator i4 = labels.iterator();
					while (i4.hasNext()) {
						Comparable c4 = (Comparable) (i4.next());
						if (!haveMetHistorical
							&& c1 == ch1
							&& c2 == ch2
							&& c3 == ch3
							&& c4 == ch4) {
							haveMetHistorical = true;
							//System.out.println("OK have met historical data");
						}
						//System.out.println("are these distinct?"+c1+c2+c3+c4);
						//System.out.println("met historical?"+haveMetHistorical);
						else if (
							haveMetHistorical
								&& c1 != c2
								&& c1 != c3
								&& c1 != c4
								&& c2 != c3
								&& c2 != c4
								&& c3 != c4) {
							//System.out.println("OK have found distinct "+c1+c2+c3+c4);
							Iterator itNodes = g.nodes().iterator();
							while (itNodes.hasNext()) {
								Node n = (Node) (itNodes.next());
								//System.out.println("edges are "+g.edges);
								// seeking situations where we can find missing edges
								if (//       v.along(3).along(4)- v.along(2).along(3).along(4)
								!g
									.edges()
									.contains(
										Edge.getEdge(
											n.along(c3).along(c4),
											n.along(c2).along(c3).along(c4)))
									&& //v.along(1).along(3).along(4)- v.along(1).along(2).along(3).along(4)
								!g
										.edges()
										.contains(
											Edge.getEdge(
												n.along(c1).along(c3).along(c4),
												n.along(c1).along(c2).along(
													c3).along(
													c4)))
									&& ((// and EITHER
								//       v                  - v.along(1)
								!g
										.edges()
										.contains(Edge.getEdge(n, n.along(c1)))
									&& //       v.along(2)        - v.along(1).along(2)
								!g
									.edges()
									.contains(
										Edge.getEdge(
											n.along(c2),
											n.along(c1).along(c2))))
										|| (// OR
								//       v.along(3)          - v.along(2).along(3)
								!g
											.edges()
											.contains(
												Edge.getEdge(
													n.along(c3),
													n.along(c2).along(c3)))
									&& //       v.along(1).along(3)- v.along(1).along(2).along(3)
								!g
									.edges()
									.contains(
										Edge.getEdge(
											n.along(c1).along(c3),
											n.along(c1).along(c2).along(
												c3))))))

									// two extra brackets here....
									{ //
									// in which case
									// fix the ordering L = <l1,l2,l3,l4> and the vertex v
									// for each vertex v2, find a set of labels from v to v2
									// and use L to convert it to 0110, for example
									// pick this position from a position array
									//System.out.println("found missing edges with");
									//System.out.println("node "+n+" and label order "+c1+c2+c3+c4);
									Iterator iNodes2 = g.nodes().iterator();
									while (iNodes2.hasNext()) {
										Node toBePositioned =
											(Node) (iNodes2.next());
										TreeSet symmDiff =
											n.symmDiff(toBePositioned);
										toBePositioned.setPosition(
											posns[getInt(
												symmDiff.contains(c1))][getInt(
												symmDiff.contains(c2))][getInt(
												symmDiff.contains(c3))][getInt(
												symmDiff.contains(c4))]);
									}
									updateHistory(g, c1, c2, c3, c4);
									return true;
								}
							}
						}
					}
				}
			}
		}
		return false;
	}

	private static void updateHistory(
		Graph g,
		Comparable c1,
		Comparable c2,
		Comparable c3,
		Comparable c4) {
		Iterator i = history.iterator();
		while (i.hasNext()) {
			Object o = i.next();
			//System.out.println("o's class is "+o.getClass());
			Graph gh = (Graph) (o);
			if (gh == g) {
				//Comparable co1 = (Comparable) (i.next());
				//Comparable co2 = (Comparable) (i.next());
				//Comparable co3 = (Comparable) (i.next());
				//Comparable co4 = (Comparable) (i.next());
				int n = history.indexOf(gh);
				//System.out.println(""+history);
				//System.out.println("remove "+co1+co2+co3+co4);
				history.remove(n + 1);
				history.remove(n + 1);
				history.remove(n + 1);
				history.remove(n + 1);
				//System.out.println(""+history);
				//System.out.println("replace with "+c1+c2+c3+c4);
				history.add(n + 1, c4);
				history.add(n + 1, c3);
				history.add(n + 1, c2);
				history.add(n + 1, c1);
				//System.out.println(""+history);
				return;
			}
			i.next();
			i.next();
			i.next();
			i.next();
		}
		history.add(g);
		history.add(c1);
		history.add(c2);
		history.add(c3);
		history.add(c4);
	}
	///////////////////////////////////////////////////////////////////////////

	private static int getInt(boolean b) {
		if (b) {
			return 1;
		} else {
			return 0;
		}
	}
}
