package rwd.rules;
import rwd.abstractsyntax.eulerdiagram.Zone;
import rwd.abstractsyntax.spiderdiagram.UnitaryDiagram;
import java.util.Vector;
import rwd.abstractsyntax.spiderdiagram.Spider;

public class NoProofException extends Exception {
	String message;
	public NoProofException(UnitaryDiagram ud) {
		Vector zones = ud.getCloneOfZoneSet();
		Vector numbers = new Vector();
		for (int i = 0; i < zones.size(); i++) {
			Zone z = (Zone) zones.get(i);
			int num = 0;
			for (int j = 0; j < ud.getSpiders().size(); j++) {
				if (((Spider) ud.getSpiders().get(j))
					.getHabitat()
					.contains(z)) {
					num++;
				}
			}
			numbers.add(new Integer(num));
		}
		String result = "counter-example:";
		for (int i = 0; i < zones.size(); i++) {
			result =
				result + "\n" + numbers.get(i) + " elements in " + zones.get(i);
		}
		message = result;
	}
	public NoProofException(String message) {
		this.message = message;
	}
	public String getCounterExample() {
		return message;
	}
}
