package rwd.rules.choicespec;
import rwd.rules.Rule;
import rwd.rules.application.RuleApplicationSpec;

import java.util.Vector;
import rwd.abstractsyntax.spiderdiagram.Diagram;
public abstract class RuleWithChoice extends Rule {
	public RuleWithChoice(String s) {
		super(s);
	}
	public abstract Vector getApplicationPossibilities(Diagram d);
	//public boolean canApplyTo(Diagram d)
	//{ return getApplicationPossibilities(d).size()>0; }
    
    public RuleApplicationSpec findApplicableSpec(Diagram part){
        Vector specs = this.getApplicationPossibilities(part);
        if(specs.size()==0){
            return null;
        } else {
            return (RuleApplicationSpec)specs.get(0);
        }
        
    }
}
