package rwd.rules.nospec;

import rwd.abstractsyntax.spiderdiagram.Diagram;
import rwd.rules.Rule;
import rwd.rules.application.RuleAppliesToJustADiagram;
import rwd.rules.application.RuleApplicationSpec;
import java.util.Vector;
import rwd.abstractsyntax.spiderdiagram.FalseDiagram;
import rwd.abstractsyntax.spiderdiagram.OrCompoundDiagram;

public class RulePToPorF extends RuleNoSpec {
	public RulePToPorF() {
		super("sd: P->PorF");
	}
	private static Rule example = null;

	public static Rule getRule() {
		if (example == null) {
			example = new RulePToPorF();
		}
		return example;
	}
    public boolean isInvertible(){
        return true;
    }

	public boolean canApplyTo(Diagram d) {
		return true;
	}

	public Diagram applyRule(RuleApplicationSpec r) {
		RuleAppliesToJustADiagram rajd = (RuleAppliesToJustADiagram) r;
		Diagram d = rajd.d;
		//System.out.println("applying rwd.rules to "+d);
		Vector diagrams = new Vector();
		diagrams.add(d);
		diagrams.add(new FalseDiagram("f"));
		Diagram dnew = new OrCompoundDiagram(diagrams, "outcome");
		//System.out.println("returning "+dnew);
		return dnew;
	}
}
