package rwd.tableaux.syntax.ast;

/**
 * @author Octavian Patrascoiu
 *
 */
public interface AstFactory {
	public LogicalExp buildAtomicExp(String name, Object loc);
	public LogicalExp buildNotExp(LogicalExp left, Object loc);
	public LogicalExp buildAndExp(LogicalExp left, LogicalExp right, Object loc);
	public LogicalExp buildOrExp(LogicalExp left, LogicalExp right, Object loc);
	public LogicalExp buildImpliesExp(LogicalExp left, LogicalExp right, Object loc);
	public LogicalExp buildEquivalentExp(LogicalExp left, LogicalExp right, Object loc);
}
