package rwd.views.abstracttoconcrete.forcemodel.layout;

import rwd.views.abstracttoconcrete.forcemodel.*;

/**
 * @author  $Author: op $
 * @version $Id: RandomLayout.java,v 1.5 2004/10/20 10:08:39 op Exp $
 */
public class RandomLayout implements Layout {
    
    public RandomLayout() {
        this(100);
    }
    
    public RandomLayout(double size) {
        _size = size;
    }
    
    public void apply(Graph graph) {
        Node[] nodes = graph.getNodeArray();
        for (int i = 0; i < nodes.length; i++) {
            Node node = nodes[i];
            node.setX(Math.random() * _size);
            node.setY(Math.random() * _size);
        }
    }

    
    private double _size;
    
}
